rm(list=ls(all=TRUE))
require(tseries)
n=200
QMLEarch=function(){
  temp=rep(0,(n+100))
  temp[1]=rnorm(1)
  e=rnorm((n+100),0,1)
  for (i in 1:(n-1+100)){
    temp[i+1]=sqrt(.5+.25*temp[i]^2)*e[i+1]
  }
  x=temp[101:(100+n)]
  y=x^2
  fit=garch(x,c(0,1),trace=F)
  e=rep(NA,n-1)
  for(i in 1:(n-1)){
    e[i]=x[i+1]/sqrt(fit$coef[1]+fit$coef[2]*y[i])
  }
  er=e-mean(e)
  #bootstrap
  bootstrap=function(){
    bb=rep(NA,(n+100))
    bb[1]=x[1]
    estar=sample(er,(n+100),replace=TRUE)
    for(i in 1:(99+n)){
      bb[i+1]=sqrt(fit$coef[2]*(bb[i])^2+fit$coef[1])*estar[i+1]		
    }
    b=bb[101:(100+n)]
    list(b=b)
  }
  fvstar=rep(NA,1000)#Jonathan
  for (i in 1:1000){
    result=bootstrap()
    xstar=result$b
    fitstar=garch(xstar,c(0,1),trace=F)
    fvstar[i]=sqrt(fitstar$coef[2]*x[n]^2+fitstar$coef[1])*sample(er,1)
  }
  fvstar=fvstar[!is.na(fvstar)]
  up=quantile(fvstar,.975)
  down=quantile(fvstar,.025)
  up90=quantile(fvstar,.95)
  down90=quantile(fvstar,.05)
  l=up-down
  l90=up90-down90
  c=0
  c90=0
  truevalue=rep(0,1000)
  for (i in 1:1000){
    truevalue[i]=sqrt(.5+.25*y[n])*rnorm(1,0,1)
    if((truevalue[i]<up) & truevalue[i]>down) c=c+1
    if((truevalue[i]<up90) & truevalue[i]>down90) c90=c90+1
  }
  list(c=c/1000,l=l,c90=c90/1000,l90=l90)
}

c=rep(NA,500)
c90=rep(NA,500)
l=rep(NA,500)
l90=rep(NA,500)
for (i in 1:500){
  set.seed(5*i)
  results=QMLEarch()
  c[i]=results$c
  c90[i]=results$c90
  l[i]=results$l
  l90[i]=results$l90
  print(i)
  save.image("C:/Users/panli_000/Dropbox/time series/new sim/ARCH/workspace/arch1normal_qmle200.RData")
}
print(mean(c))
print(mean(l))
print(sd(l))
print(mean(c90))
print(mean(l90))
print(sd(l90))
