rm(list=ls(all=TRUE))
n=50
phi=0.9
arboots=function()
{
	temp=rep(0,(n+100))
	temp[1]=rnorm(1)
	e=rlaplace((n+100),0,1/sqrt(2))
	for (i in 1:(n-1+100)){
		temp[i+1]=phi*(temp[i])+e[i+1]
	}
	u=temp[101:(100+n)]
	x=u[1:(n-1)]
	y=u[2:n]
	fit=lm(y~x)
	fvhat=predict(fit,data.frame(x=u[n]))
	e=fit$resid
	er=e-mean(e)
	sigmahat=sd(er)#sigma
	resid=rep(0,(n-1))
	for (i in 1:(n-1)){
		xtemp=x[-i]
		ytemp=y[-i]
		tempfit=lm(ytemp~xtemp)
		resid[i]=y[i]-predict(tempfit,data.frame(xtemp=x[i]))
	}
	res=resid-mean(resid)
	arbootstrap=function(residuals){
		bb=rep(0,(n+100))
		bb[1]=u[1]
		estar=sample(residuals,(n+101),replace=TRUE)
		for(i in 1:(99+n)){
			bb[i+1]=fit$coef[2]*bb[i]+fit$coef[1]+estar[i+1]		
		}
		b=bb[101:(100+n)]
		fv=fit$coef[2]*u[n]+fit$coef[1]+estar[(n+101)]
		list(b=b,fv=fv)
	}
	Ffstar=rep(NA,1000)
	Ffhat=rep(NA,1000)
	FSfbr=rep(NA,1000)
	for(i in 1:1000){
		result=arbootstrap(er)
		ustar=result$b
		xstar=ustar[1:(n-1)]
		ystar=ustar[2:(n)]
		fitstar=lm(ystar~xstar)
		Ffhat[i]=fitstar$coef[2]*u[n]+fitstar$coef[1]
		Ffstar[i]=result$fv
		sigmastar=sd(fitstar$resid)#sigma*
		FSfbr[i]=(Ffstar[i]-Ffhat[i])/sigmastar
	}
	Fpstar=rep(NA,1000)
	Fphat=rep(NA,1000)
	FSpbr=rep(NA,1000)
	for(i in 1:1000){
		result=arbootstrap(res)
		ustar=result$b
		xstar=ustar[1:(n-1)]
		ystar=ustar[2:(n)]
		fitstar=lm(ystar~xstar)
		Fphat[i]=fitstar$coef[2]*u[n]+fitstar$coef[1]
		Fpstar[i]=result$fv
		sigmastar=sd(fitstar$resid)#sigma*
		FSpbr[i]=(Fpstar[i]-Fphat[i])/sigmastar
	}
	
	backarbootstrap=function(residuals){
	estar=rep(0,(n+101))
	wstar=rep(0,(n+100))
	estar=sample(residuals,n+101,replace=TRUE)
	wstar[1]=estar[1]-fit$coef[2]*estar[2]
	for(i in 1:(99+n)){
		wstar[i+1]=fit$coef[2]*wstar[i]+estar[i+1]-fit$coef[2]*estar[i+2]
		}
	backerr=wstar[101:(100+n)]
	b=rep(0,n)
	b[n]=u[n]
	for(i in 1:(n-1)){
	b[n-i]=fit$coef[1]+fit$coef[2]*b[n-i+1]+backerr[n-i]
	}
	fv=fit$coef[2]*u[n]+fit$coef[1]+estar[n+101]
	list(b=b,fv=fv)
	}
	Bfhat=rep(NA,1000)
	Bfstar=rep(NA,1000)
	BSfbr=rep(NA,1000)
	for(i in 1:1000){
		result=backarbootstrap(er)
		ustar=result$b
		xstar=ustar[1:(n-1)]
		ystar=ustar[2:n]
		fitstar=lm(ystar~xstar)
		Bfhat[i]=fitstar$coef[2]*u[n]+fitstar$coef[1]
		Bfstar[i]=result$fv
		sigmastar=sd(fitstar$resid)
		BSfbr[i]=(Bfstar[i]-Bfhat[i])/sigmastar
	}
	Bphat=rep(NA,1000)
	Bpstar=rep(NA,1000)
	BSpbr=rep(NA,1000)
	for(i in 1:1000){
		result=backarbootstrap(res)
		ustar=result$b
		xstar=ustar[1:(n-1)]
		ystar=ustar[2:n]
		fitstar=lm(ystar~xstar)
		Bphat[i]=fitstar$coef[2]*u[n]+fitstar$coef[1]
		Bpstar[i]=result$fv
		sigmastar=sd(fitstar$resid)
		BSpbr[i]=(Bpstar[i]-Bphat[i])/sigmastar
	}

	#Ff
	Ffdown=fvhat+quantile(Ffstar-Ffhat,.025)
	Ffup=fvhat+quantile(Ffstar-Ffhat,.975)
	Ffl=Ffup-Ffdown
	Ffdown90=fvhat+quantile(Ffstar-Ffhat,.05)
	Ffup90=fvhat+quantile(Ffstar-Ffhat,.95)
	Ffl90=Ffup90-Ffdown90
	#Fp
	Fpdown=fvhat+quantile(Fpstar-Fphat,.025)
	Fpup=fvhat+quantile(Fpstar-Fphat,.975)
	Fpl=Fpup-Fpdown
	Fpdown90=fvhat+quantile(Fpstar-Fphat,.05)
	Fpup90=fvhat+quantile(Fpstar-Fphat,.95)
	Fpl90=Fpup90-Fpdown90
	#Bf
	Bfdown=fvhat+quantile(Bfstar-Bfhat,.025)
	Bfup=fvhat+quantile(Bfstar-Bfhat,.975)
	Bfl=Bfup-Bfdown
	Bfdown90=fvhat+quantile(Bfstar-Bfhat,.05)
	Bfup90=fvhat+quantile(Bfstar-Bfhat,.95)
	Bfl90=Bfup90-Bfdown90
	#Bp
	Bpdown=fvhat+quantile(Bpstar-Bphat,.025)
	Bpup=fvhat+quantile(Bpstar-Bphat,.975)
	Bpl=Bpup-Bpdown
	Bpdown90=fvhat+quantile(Bpstar-Bphat,.05)
	Bpup90=fvhat+quantile(Bpstar-Bphat,.95)
	Bpl90=Bpup90-Bpdown90
	#FSf
	FSfdown=fvhat+quantile(FSfbr,.025)*sigmahat
	FSfup=fvhat+quantile(FSfbr,.975)*sigmahat
	FSfl=FSfup-FSfdown
	FSfdown90=fvhat+quantile(FSfbr,.05)*sigmahat
	FSfup90=fvhat+quantile(FSfbr,.95)*sigmahat
	FSfl90=FSfup90-FSfdown90
	#FSp
	FSpdown=fvhat+quantile(FSpbr,.025)*sigmahat
	FSpup=fvhat+quantile(FSpbr,.975)*sigmahat
	FSpl=FSpup-FSpdown
	FSpdown90=fvhat+quantile(FSpbr,.05)*sigmahat
	FSpup90=fvhat+quantile(FSpbr,.95)*sigmahat
	FSpl90=FSpup90-FSpdown90
	#BSf
	BSfdown=fvhat+quantile(BSfbr,.025)*sigmahat
	BSfup=fvhat+quantile(BSfbr,.975)*sigmahat
	BSfl=BSfup-BSfdown
	BSfdown90=fvhat+quantile(BSfbr,.05)*sigmahat
	BSfup90=fvhat+quantile(BSfbr,.95)*sigmahat
	BSfl90=BSfup90-BSfdown90
	#BSp
	BSpdown=fvhat+quantile(BSpbr,.025)*sigmahat
	BSpup=fvhat+quantile(BSpbr,.975)*sigmahat
	BSpl=BSpup-BSpdown
	BSpdown90=fvhat+quantile(BSpbr,.05)*sigmahat
	BSpup90=fvhat+quantile(BSpbr,.95)*sigmahat
	BSpl90=BSpup90-BSpdown90
	
	truevalue=rep(0,1000)
		for (i in 1:1000){
		truevalue[i]=phi*(u[n])+rlaplace(1,0,1/sqrt(2))
	}

	Ff=0
	Fp=0
	Bf=0
	Bp=0
	FSf=0
	FSp=0
	BSf=0
	BSp=0
	Ff90=0
	Fp90=0
	Bf90=0
	Bp90=0
	FSf90=0
	FSp90=0
	BSf90=0
	BSp90=0
	for (i in 1:1000){
		if((truevalue[i]<Ffup) & truevalue[i]>Ffdown)
			Ff=Ff+1
		if((truevalue[i]<Fpup) & truevalue[i]>Fpdown)
			Fp=Fp+1
		if((truevalue[i]<Bfup) & truevalue[i]>Bfdown)
			Bf=Bf+1
		if((truevalue[i]<Bpup) & truevalue[i]>Bpdown)
			Bp=Bp+1
		if((truevalue[i]<FSfup) & truevalue[i]>FSfdown)
			FSf=FSf+1
		if((truevalue[i]<FSpup) & truevalue[i]>FSpdown)
			FSp=FSp+1
		if((truevalue[i]<BSfup) & truevalue[i]>BSfdown)
			BSf=BSf+1
		if((truevalue[i]<BSpup) & truevalue[i]>BSpdown)
			BSp=BSp+1
		if((truevalue[i]<Ffup90) & truevalue[i]>Ffdown90)
			Ff90=Ff90+1
		if((truevalue[i]<Fpup90) & truevalue[i]>Fpdown90)
			Fp90=Fp90+1
		if((truevalue[i]<Bfup90) & truevalue[i]>Bfdown90)
			Bf90=Bf90+1
		if((truevalue[i]<Bpup90) & truevalue[i]>Bpdown90)
			Bp90=Bp90+1
		if((truevalue[i]<FSfup90) & truevalue[i]>FSfdown90)
			FSf90=FSf90+1
		if((truevalue[i]<FSpup90) & truevalue[i]>FSpdown90)
			FSp90=FSp90+1
		if((truevalue[i]<BSfup90) & truevalue[i]>BSfdown90)
			BSf90=BSf90+1
		if((truevalue[i]<BSpup90) & truevalue[i]>BSpdown90)
			BSp90=BSp90+1
		
	}
	Ffc=Ff/1000
	Fpc=Fp/1000
	Bfc=Bf/1000
	Bpc=Bp/1000
	FSfc=FSf/1000
	FSpc=FSp/1000
	BSfc=BSf/1000
	BSpc=BSp/1000
	Ffc90=Ff90/1000
	Fpc90=Fp90/1000
	Bfc90=Bf90/1000
	Bpc90=Bp90/1000
	FSfc90=FSf90/1000
	FSpc90=FSp90/1000
	BSfc90=BSf90/1000
	BSpc90=BSp90/1000

	list(Ffc=Ffc,Fpc=Fpc,Bfc=Bfc,Bpc=Bpc,FSfc=FSfc,FSpc=FSpc,BSfc=BSfc,BSpc=BSpc,Ffl=Ffl,Fpl=Fpl,Bfl=Bfl,Bpl=Bpl,FSfl=FSfl,FSpl=FSpl,BSfl=BSfl,BSpl=BSpl,
	Ffc90=Ffc90,Fpc90=Fpc90,Bfc90=Bfc90,Bpc90=Bpc90,FSfc90=FSfc90,FSpc90=FSpc90,BSfc90=BSfc90,BSpc90=BSpc90,Ffl90=Ffl90,Fpl90=Fpl90,Bfl90=Bfl90,Bpl90=Bpl90,
	FSfl90=FSfl90,FSpl90=FSpl90,BSfl90=BSfl90,BSpl90=BSpl90)
}

require(VGAM)

Ffc=rep(NA,500)
Fpc=rep(NA,500)
Bfc=rep(NA,500)
Bpc=rep(NA,500)
FSfc=rep(NA,500)	
FSpc=rep(NA,500)
BSfc=rep(NA,500)
BSpc=rep(NA,500)
Ffc90=rep(NA,500)
Fpc90=rep(NA,500)
Bfc90=rep(NA,500)
Bpc90=rep(NA,500)
FSfc90=rep(NA,500)
FSpc90=rep(NA,500)
BSfc90=rep(NA,500)	
BSpc90=rep(NA,500)
Ffl=rep(NA,500)
Fpl=rep(NA,500)
Bfl=rep(NA,500)
Bpl=rep(NA,500)
FSfl=rep(NA,500)	
FSpl=rep(NA,500)
BSfl=rep(NA,500)
BSpl=rep(NA,500)
Ffl90=rep(NA,500)
Fpl90=rep(NA,500)
Bfl90=rep(NA,500)
Bpl90=rep(NA,500)
FSfl90=rep(NA,500)
FSpl90=rep(NA,500)
BSfl90=rep(NA,500)	
BSpl90=rep(NA,500)
for (i in 1:500){
  set.seed(5*i)
  results=arboots()
  Ffc[i]=results$Ffc
  Fpc[i]=results$Fpc
  Bfc[i]=results$Bfc
  Bpc[i]=results$Bpc
  FSfc[i]=results$FSfc
  FSpc[i]=results$FSpc
  BSfc[i]=results$BSfc
  BSpc[i]=results$BSpc
  Ffl[i]=results$Ffl
  Fpl[i]=results$Fpl
  Bfl[i]=results$Bfl
  Bpl[i]=results$Bpl
  FSfl[i]=results$FSfl
  FSpl[i]=results$FSpl
  BSfl[i]=results$BSfl
  BSpl[i]=results$BSpl
  Ffc90[i]=results$Ffc90
  Fpc90[i]=results$Fpc90
  Bfc90[i]=results$Bfc90
  Bpc90[i]=results$Bpc90
  FSfc90[i]=results$FSfc90
  FSpc90[i]=results$FSpc90
  BSfc90[i]=results$BSfc90
  BSpc90[i]=results$BSpc90
  Ffl90[i]=results$Ffl90
  Fpl90[i]=results$Fpl90
  Bfl90[i]=results$Bfl90
  Bpl90[i]=results$Bpl90
  FSfl90[i]=results$FSfl90
  FSpl90[i]=results$FSpl90
  BSfl90[i]=results$BSfl90
  BSpl90[i]=results$BSpl90
  save.image("C:/Users/Penny/Dropbox/time series/new sim/linear/ar/8 methods/workspaces/ar1_09_laplace50.RData")
  print(i)
}
print(mean(Ffc))
print(mean(Fpc))
print(mean(Bfc))
print(mean(Bpc))
print(mean(FSfc))
print(mean(FSpc))
print(mean(BSfc))
print(mean(BSpc))
print(mean(Ffl))
print(mean(Fpl))
print(mean(Bfl))
print(mean(Bpl))
print(mean(FSfl))
print(mean(FSpl))
print(mean(BSfl))
print(mean(BSpl))
print(sd(Ffl))
print(sd(Fpl))
print(sd(Bfl))
print(sd(Bpl))
print(sd(FSfl))
print(sd(FSpl))
print(sd(BSfl))
print(sd(BSpl))
print(mean(Ffc90))
print(mean(Fpc90))
print(mean(Bfc90))
print(mean(Bpc90))
print(mean(FSfc90))
print(mean(FSpc90))
print(mean(BSfc90))
print(mean(BSpc90))
print(mean(Ffl90))
print(mean(Fpl90))
print(mean(Bfl90))
print(mean(Bpl90))
print(mean(FSfl90))
print(mean(FSpl90))
print(mean(BSfl90))
print(mean(BSpl90))
print(sd(Ffl90))
print(sd(Fpl90))
print(sd(Bfl90))
print(sd(Bpl90))
print(sd(FSfl90))
print(sd(FSpl90))
print(sd(BSfl90))
print(sd(BSpl90))
